#define MAX_QPATH		64
#define MAX_PARMS		8

typedef struct cg_stats_s
{
	char	name[MAX_QPATH];
	uint	value;	

} cg_stats_t;

typedef struct cg_cvars_s
{
	char	name[MAX_QPATH];
	char	cvar[MAX_QPATH];

} cg_cvars_t;

typedef struct cg_def_s
{
	int	val[2];
	int	op;

} cg_def_t;

// cg expression types
enum
{
	OP_UNKNOWN = 0,
	OP_LOGIC_OR,
	OP_LOGIC_AND,
	OP_EQUAL,
	OP_NOTEQUAL,
	OP_MORE,
	OP_MORE_OR_EQUAL,
	OP_SMALLER,
	OP_SMALLER_OR_EQUAL,
	OP_WITH,
};

typedef struct;
{
	// hudprogram stack
	byte		*hud_program;
	uint		hud_program_size;

	bool		cg_init;
	char		cg_function[MAX_QPATH];
	char		cg_builtin[MAX_QPATH];
	char		cg_tempstring[MAX_QPATH];
	int		cg_depth;
	int		cg_depth2; // used for bounds chekiing
	char		cg_argv[MAX_PARMS][MAX_QPATH];
	uint		cg_argc;
	cg_stats_t	cg_stats[MAX_STATS];
	uint		cg_numstats;
	cg_cvars_t	cg_cvars[128];
	uint		cg_numcvars;
	vec4_t		cg_color;
	vec2_t		cg_scale;
		
} client_static_t;

extern client_static_t	cls;